#include "stddef.h"
#include "getperf.h"

//
//  ,  
const int critical_percent = 80;

DWORD CALLBACK Thread(LPVOID p);

int APIENTRY WinMain(HINSTANCE, HINSTANCE, PSTR, int)
{
	HANDLE hEnd = CreateEvent(NULL, TRUE, FALSE, NULL);

	HANDLE hThread;

	hThread = CreateThread(NULL, 0, Thread, hEnd, 0, NULL);

	MessageBox(NULL, TEXT("Stop killings"), TEXT("Processor Protecter"), MB_OK);

	SetEvent(hEnd);

	WaitForSingleObject(hThread, INFINITE);

	return 0;
}

//
// ,    
DWORD CALLBACK Thread(LPVOID p)
{
	HANDLE hEnd = p;

	LARGE_INTEGER frequency;
	LARGE_INTEGER time_1;
	LARGE_INTEGER value_1;

	get_perf::processor_time(&value_1);

	QueryPerformanceCounter(&time_1);
	QueryPerformanceFrequency(&frequency);

	LARGE_INTEGER time_2;
	LARGE_INTEGER value_2;

	for (;;)
	{
		if (WaitForSingleObject(hEnd, 1000) == WAIT_OBJECT_0)
		{
			break;
		}

		if (get_perf::processor_time(&value_2) != 0)
		{
			//    
			continue;
		}

		QueryPerformanceCounter(&time_2);

		double time = (time_2.QuadPart - time_1.QuadPart) * 10000000.0 / frequency.QuadPart;
		double res = (1.0 - (value_2.QuadPart - value_1.QuadPart) / time) * 100;

		time_1  = time_2;
		value_1 = value_2;

		if (res < critical_percent)
		{
			//   ,  
			continue;
		}

		//   !

		DWORD*  ids;
		WCHAR** names;
		int     count;

		if (get_perf::processes_info(&ids, &names, &count) != 0)
		{
			//    
			continue;
		}

		for (int i = 0; i < count; i++)
		{
			//   _Total
			if (ids[i] == 0) continue;
			//   
			if (ids[i] == GetCurrentProcessId()) continue;

			HANDLE hProc = OpenProcess(PROCESS_TERMINATE, FALSE, ids[i]);

			if (!hProc)
			{
				//   -  
				continue;
			}
			
			if (TerminateProcess(hProc, 0))
			{
				// !
				CloseHandle(hProc);
				break;
			}

			CloseHandle(hProc);
		}

		free(ids);
		free(names);
	}

	return 0;
}