//
//  Copyright (C) 2003,  . All Rights Reserved.
//
//  PROJECT:    Performance Counter Viewer
//
//  MODULE:     perfobjects.h
//
//  PURPOSE:     .   ,    
//                    
//               .    .
//
//  AUTHOR(S):   
//
//  PLATFORMS:  Windows NT/2000/XP
//
//  CLASSES:
//      perf_data_block
//      perf_object_type
//      perf_instance_definition
//

#ifndef PERFOBJECTS_H
#define PERFOBJECTS_H

//
//    PERF_DATA_BLOCK
class perf_data_block
{
public:

	class iterator
	{
	public:

		iterator(const PERF_DATA_BLOCK* d);
		
		// ,       
		bool is_any() const; 

		//       
		const PERF_OBJECT_TYPE* get_first(); 
		//      
		const PERF_OBJECT_TYPE* get_next();

	private:
		const PERF_DATA_BLOCK* _data;
		DWORD                  _offset;
		DWORD                  _num;
	};

	perf_data_block(const void* d);

	//    
	const WCHAR* name() const; 
	//   
	int name_len() const;

	//  
	iterator get_iterator() const;

	const PERF_DATA_BLOCK* _data;
};

//
//    PERF_OBJECT_TYPE
class perf_object_type
{
public:

	class counter_iterator
	{
	public:

		counter_iterator(const PERF_OBJECT_TYPE* d);
		
		// ,       
		bool is_any() const;

		//       
		const PERF_COUNTER_DEFINITION* get_first();
		//      
		const PERF_COUNTER_DEFINITION* get_next();

	private:
		const PERF_OBJECT_TYPE* _data;
		DWORD                   _offset;
		DWORD                   _num;
	};

	class instance_iterator
	{
	public:

		instance_iterator(const PERF_OBJECT_TYPE* d);
		
		// ,       
		bool is_any() const;

		//       
		const PERF_INSTANCE_DEFINITION* get_first();
		//      
		const PERF_INSTANCE_DEFINITION* get_next();

	private:
		const PERF_OBJECT_TYPE* _data;
		DWORD                   _offset;
		LONG                    _num;
	};


	perf_object_type(const void* d);

	//     
	bool is_instances() const;

	//    
	counter_iterator get_counter_iterator() const;
	//    
	instance_iterator get_instance_iterator() const;

	const PERF_OBJECT_TYPE* _data;
};

//
//    PERF_INSTANCE_DEFINITION
class perf_instance_definition
{
public:

	perf_instance_definition(const void* d);

	//  .   ,     Unicode
	const WCHAR* name() const; 	
	//   .   ,     Unicode
	int name_len() const;

	//      .
	const char* get_counter_block() const;

	const PERF_INSTANCE_DEFINITION* _data;
};


#endif //PERFOBJECTS_H