//
//  Copyright (C) 2003, .
//
//  PROJECT:    
//
//  MODULE:     mainwnd.cpp
//
//  PURPOSE:       
//
//  AUTHOR(S):   
//
//  PLATFORMS:  Windows 2000/XP/NT/9x
//
//  CLASSES:  
//       CMainWnd
//

#include "stdwtl.h"
#include "mainwnd.h"
#include "waitcursor.h"
#include "message.h"
#include "otherdlg.h"
#include "./perf/counterhelpdb.h"
#include "infodlg.h"

//////////////////////////////////////////////////////////////////////
//
//  CMainWindow
//
//////////////////////////////////////////////////////////////////////

//  
//  FUNCTION:     CMainWindow(void)
//
//  PARAMETERS:   
//
//  RETURN VALUE: 
//
//  REVISION:     19.07.2002   
//
//  PURPOSE:      .    
//                   
//
//  COMMENTS:     
//
CMainWindow::CMainWindow()
{
	GetWndClassInfo().m_wc.hbrBackground = (HBRUSH)GetStockObject(NULL_BRUSH);
	GetWndClassInfo().m_wc.lpszMenuName  = MAKEINTRESOURCE(IDR_MENU);
	GetWndClassInfo().m_wc.hIcon         = NULL;
	GetWndClassInfo().m_wc.hIconSm       = GetWndClassInfo().m_wc.hIcon;
}

//  
//  FUNCTION:     ~CMainWindow(void)
//
//  PARAMETERS:   
//
//  RETURN VALUE: 
//
//  REVISION:     19.07.2002   
//
//  PURPOSE:      . 
//
//  COMMENTS:     
//
CMainWindow::~CMainWindow()
{
}

//////////////////////////////////////////////////////////////
//
//  
//
//////////////////////////////////////////////////////////////

//  
//  FUNCTION:     LRESULT OnCreate(CREATESTRUCT*)
//
//  PARAMETERS:   [IN] cs -   
//
//  RETURN VALUE: 0  -  
//                -1 -   
//
//  REVISION:     19.07.2002   
//
//  PURPOSE:        
//
//  COMMENTS:     
//
LRESULT CMainWindow::OnCreate(CREATESTRUCT* cs)
{
	_splitter.Create(
				*this, 
				rcDefault, 
				NULL, 
				WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, 
				0);

	_splitter.m_cxySplitBar /= 2;

	if (_list.Create(_splitter) && _tree.Create(_splitter)) 
	{
		_splitter.SetSplitterPanes(_tree, _list);

		RECT rc = {0, 0, 100, 100};
		_splitter.SetSplitterRect(&rc);
		_splitter.SetSplitterPos(30);

		SendMessage(WM_COMMAND, ID_TITLES_009);
		SendMessage(WM_COMMAND, ID_TITLES_HKLM);
		SendMessage(WM_COMMAND, ID_TITLES_RELOAD);
		
		return 0;
	}
	
	return -1;
}

//  
//  FUNCTION:     void OnSize(UINT, CSize)
//
//  PARAMETERS:   [IN] type -  
//                [IN] s    -  
//
//  RETURN VALUE: 
//
//  REVISION:     19.07.2002   
//
//  PURPOSE:           
//                   .
//
//  COMMENTS:     
//
void CMainWindow::OnSize(UINT, CSize s)
{
	_splitter.MoveWindow(0, 0, s.cx, s.cy);
}

//  
//  FUNCTION:     void OnClose(void)
//
//  PARAMETERS:   
//
//  RETURN VALUE: 
//
//  REVISION:     19.07.2002   
//
//  PURPOSE:       .
//
//  COMMENTS:     
//
void CMainWindow::OnClose()
{
	SetMsgHandled(FALSE);
}

//  
//  FUNCTION:     void OnDestroy(void)
//
//  PARAMETERS:   
//
//  RETURN VALUE: 
//
//  REVISION:     19.07.2002   
//
//  PURPOSE:       .
//
//  COMMENTS:     
//
void CMainWindow::OnDestroy()
{
	PostQuitMessage(0);
}

//////////////////////////////////////////////////////////////
//
//   
//
//////////////////////////////////////////////////////////////

//  
//  FUNCTION:     void OnGoConnect(UINT , int , HWND)
//
//  PARAMETERS:    
//
//  RETURN VALUE: 
//
//  REVISION:     19.06.2003   
//
//  PURPOSE:         Connect
//
//  COMMENTS:     
//
void CMainWindow::OnGoConnect(UINT , int , HWND )
{
	COtherDialog<IDD_OTHER_CONNECT> cd(IDC_CONNECT);

	if (!cd.DoModal(*this)) return;

	int res;

	{
		CWaitCursor wc;

		res = _data.Connect(cd.get_s());
	}

	if (res != 0)
	{
		message::format_error(*this, IDS_E_CONNECT, res);
		return;
	}

	CounterHelpDB::Connect(cd.get_s());
}

//
//     
//

void CMainWindow::OnGoGlobal(UINT , int , HWND )
{
	CWaitCursor wc;

	int res = _data.GoGlobal();

	if (res != 0)
	{
		message::format_error(*this, IDS_E_READ_DATA, res);
		return;
	}

	_tree.Clear();
	_tree.Fill(_data.ActualSizeInBytes(), _data.Get());
}

void CMainWindow::OnGoCostly(UINT , int , HWND )
{
	CWaitCursor wc;

	int res = _data.GoCostly();

	if (res != 0)
	{
		message::format_error(*this, IDS_E_READ_DATA, res);
		return;
	}

	_tree.Clear();
	_tree.Fill(_data.ActualSizeInBytes(), _data.Get());
}

void CMainWindow::OnGoOther(UINT , int , HWND )
{
	COtherDialog<IDD_OTHER_COUNTERS> cd(IDC_COUNTERS);

	if (!cd.DoModal(*this)) return;

	CWaitCursor wc;

	int res = _data.GoUser(cd.get_s());

	if (res != 0)
	{
		message::format_error(*this, IDS_E_READ_DATA, res);
		return;
	}

	_tree.Clear();
	_tree.Fill(_data.ActualSizeInBytes(), _data.Get());
}

//
//      
//

void CMainWindow::OnTitles009(UINT , int id, HWND )
{
	HMENU hmenu = GetMenu();

	if (GetMenuState(hmenu, id, MF_BYCOMMAND) & MF_CHECKED)
	{
		return;
	}

	CounterHelpDB::Use009();

	CheckMenuRadioItem(hmenu, ID_TITLES_009, ID_TITLES_OTHER, ID_TITLES_009, MF_BYCOMMAND);
}

void CMainWindow::OnTitlesGSDUIL(UINT , int id, HWND )
{
	HMENU hmenu = GetMenu();

	if (GetMenuState(hmenu, id, MF_BYCOMMAND) & MF_CHECKED)
	{
		return;
	}

	CounterHelpDB::UseGetSystemDefaultUILanguage();

	CheckMenuRadioItem(hmenu, ID_TITLES_009, ID_TITLES_OTHER, ID_TITLES_GET, MF_BYCOMMAND);
}

void CMainWindow::OnTitlesOther(UINT , int id, HWND )
{
	COtherDialog<IDD_OTHER_LANGID> ld(IDC_LANGID);

	if (!ld.DoModal(*this)) return;

	CounterHelpDB::UseOther(ld.get_s());

	HMENU hmenu = GetMenu();
	CheckMenuRadioItem(hmenu, ID_TITLES_009, ID_TITLES_OTHER, ID_TITLES_OTHER, MF_BYCOMMAND);
}

//
//     ,    
//

void CMainWindow::OnTitlesHKLM(UINT , int id, HWND )
{
	HMENU hmenu = GetMenu();

	if (GetMenuState(hmenu, id, MF_BYCOMMAND) & MF_CHECKED)
	{
		return;
	}

	CounterHelpDB::UseHKLM();

	CheckMenuRadioItem(hmenu, ID_TITLES_HKLM, ID_TITLES_HKPNT, ID_TITLES_HKLM, MF_BYCOMMAND);
}

void CMainWindow::OnTitlesHKPD(UINT , int id, HWND )
{
	HMENU hmenu = GetMenu();

	if (GetMenuState(hmenu, id, MF_BYCOMMAND) & MF_CHECKED)
	{
		return;
	}

	CounterHelpDB::UseHKPD();

	CheckMenuRadioItem(hmenu, ID_TITLES_HKLM, ID_TITLES_HKPNT, ID_TITLES_HKPD, MF_BYCOMMAND);
}

void CMainWindow::OnTitlesHKPT(UINT , int id, HWND )
{
	HMENU hmenu = GetMenu();

	if (GetMenuState(hmenu, id, MF_BYCOMMAND) & MF_CHECKED)
	{
		return;
	}

	CounterHelpDB::UseHKPT();

	CheckMenuRadioItem(hmenu, ID_TITLES_HKLM, ID_TITLES_HKPNT, ID_TITLES_HKPT, MF_BYCOMMAND);
}

void CMainWindow::OnTitlesHKPNT(UINT , int id, HWND )
{
	HMENU hmenu = GetMenu();

	if (GetMenuState(hmenu, id, MF_BYCOMMAND) & MF_CHECKED)
	{
		return;
	}

	CounterHelpDB::UseHKPNT();

	CheckMenuRadioItem(hmenu, ID_TITLES_HKLM, ID_TITLES_HKPNT, ID_TITLES_HKPNT, MF_BYCOMMAND);
}

//
//  
//

void CMainWindow::OnTitlesReload(UINT , int , HWND )
{
	CWaitCursor wc;

	int res = CounterHelpDB::Load();

	if (res != 0)
	{
		message::format_error(*this, IDS_E_LOAD_TITLES, res);
		return;
	}
}

//
//     
//

void CMainWindow::OnTitlesInfo(UINT , int , HWND )
{
	CInfoDialog d;
	d.DoModal(*this);
}

void CMainWindow::OnExit(UINT code, int id, HWND hCtrl)
{
	SendMessage(WM_CLOSE, 0);
}

//////////////////////////////////////////////////////////////
//
//  
//
//////////////////////////////////////////////////////////////

LRESULT CMainWindow::OnTreeSetChange(LPNMHDR nmhdr)
{
	FillList();
	return 0; 
}

//////////////////////////////////////////////////////////////
//
//  
//
//////////////////////////////////////////////////////////////

//
//    
void CMainWindow::FillList()
{
	int type;
	DWORD data;
	DWORD parent_type;
	DWORD parent_data;

	_tree.GetCurrentItem(&type, &data, &parent_type, &parent_data);

	switch (type)
	{
	case CObjectsTree::none:
		_list.Clear();
		break;

	case CObjectsTree::system_id:
		_list.FillSystem((const PERF_DATA_BLOCK*)data);
		break;

	case CObjectsTree::object_id:
	case CObjectsTree::multi_object_id:
		_list.FillObject((const PERF_OBJECT_TYPE*)data);
		break;

	case CObjectsTree::instance_id:
	case CObjectsTree::fake_instance_id:
		_list.FillInstance((const PERF_INSTANCE_DEFINITION*)data);
		break;

	case CObjectsTree::counter_id:

		if ((parent_type == CObjectsTree::object_id) 
			|| (parent_type == CObjectsTree::multi_object_id))
		{
			_list.FillCounter(
				(const PERF_COUNTER_DEFINITION*)data,
				(const PERF_OBJECT_TYPE*)parent_data);
		}
		else if ((parent_type == CObjectsTree::instance_id) 
			|| (parent_type == CObjectsTree::fake_instance_id))
		{
			_list.FillCounter(
				(const PERF_COUNTER_DEFINITION*)data,
				(const PERF_INSTANCE_DEFINITION*)parent_data);
		}
		break;
	}
}

///////////////////////////////////////////////////////////
