//
//  Copyright (C) 2002, AstroSoft Ltd. All Rights Reserved.
//
//  PROJECT:    Logon Manager
//
//  MODULE:     mainwnd.h
//
//  PURPOSE:       
//
//  AUTHOR(S):   
//
//  PLATFORMS:  Windows 2000/XP/NT/9x
//
//  CLASSES:  
//       CMainWindow
//

#ifndef MAINWND_H
#define MAINWND_H

#include "resource.h"
#include <atlsplit.h>
#include "objectstree.h"
#include "fieldslist.h"
#include "./perf/perfdata.h"

class CMainWindow : public CWindowImpl<CMainWindow, CWindow, CFrameWinTraits>
{
public:
	CMainWindow();
	~CMainWindow();

	BEGIN_MSG_MAP_EX(CMainWindow)

		MSG_WM_CREATE(OnCreate)
		MSG_WM_SIZE(OnSize)
		MSG_WM_CLOSE(OnClose)
		MSG_WM_DESTROY(OnDestroy)

		COMMAND_ID_HANDLER_EX(ID_GO_CONNECT,  OnGoConnect)
		COMMAND_ID_HANDLER_EX(ID_GO_GLOBAL,   OnGoGlobal)
		COMMAND_ID_HANDLER_EX(ID_GO_COSTLY,   OnGoCostly)
		COMMAND_ID_HANDLER_EX(ID_GO_OTHER,    OnGoOther)

		COMMAND_ID_HANDLER_EX(ID_TITLES_009,    OnTitles009)
		COMMAND_ID_HANDLER_EX(ID_TITLES_GET,    OnTitlesGSDUIL)
		COMMAND_ID_HANDLER_EX(ID_TITLES_OTHER,  OnTitlesOther)
		COMMAND_ID_HANDLER_EX(ID_TITLES_HKLM,   OnTitlesHKLM)
		COMMAND_ID_HANDLER_EX(ID_TITLES_HKPD,   OnTitlesHKPD)
		COMMAND_ID_HANDLER_EX(ID_TITLES_HKPT,   OnTitlesHKPT)
		COMMAND_ID_HANDLER_EX(ID_TITLES_HKPNT,  OnTitlesHKPNT)
		COMMAND_ID_HANDLER_EX(ID_TITLES_RELOAD, OnTitlesReload)
		COMMAND_ID_HANDLER_EX(ID_TITLES_INFO,   OnTitlesInfo)

		COMMAND_ID_HANDLER_EX(ID_EXIT, OnExit)

		NOTIFY_CODE_HANDLER_EX(TVN_SELCHANGED, OnTreeSetChange);
		
	END_MSG_MAP()

	//  
	LRESULT OnCreate(CREATESTRUCT* cs);
	void OnSize(UINT type, CSize s);
	void OnClose();
	void OnDestroy();

	//    Go
	void OnGoConnect(UINT code, int id, HWND hCtrl);
	void OnGoGlobal(UINT code, int id, HWND hCtrl);
	void OnGoCostly(UINT code, int id, HWND hCtrl);
	void OnGoOther(UINT code, int id, HWND hCtrl);

	//    Titles
	void OnTitles009(UINT code, int id, HWND hCtrl);
	void OnTitlesGSDUIL(UINT code, int id, HWND hCtrl);
	void OnTitlesOther(UINT code, int id, HWND hCtrl);

	void OnTitlesHKLM(UINT code, int id, HWND hCtrl);
	void OnTitlesHKPD(UINT code, int id, HWND hCtrl);
	void OnTitlesHKPT(UINT code, int id, HWND hCtrl);
	void OnTitlesHKPNT(UINT code, int id, HWND hCtrl);

	void OnTitlesReload(UINT code, int id, HWND hCtrl);
	void OnTitlesInfo(UINT code, int id, HWND hCtrl);

	// 
	void OnExit(UINT code, int id, HWND hCtrl);

	//  
	LRESULT OnTreeSetChange(LPNMHDR nmhdr);

private:

	void FillList();
	
private:

	CSplitterWindow  _splitter;
	CFieldsList      _list;
	CObjectsTree     _tree;
	CPerformanceData _data;
};

#endif //MAINWND_H