#ifndef FIELDSLIST_H
#define FIELDSLIST_H

class CFieldsList : public WTL::CListViewCtrl
{
public:

	CFieldsList();
	~CFieldsList();

	bool Create(HWND parent);
	void Clear();

	void FillSystem(const PERF_DATA_BLOCK* system);
	void FillObject(const PERF_OBJECT_TYPE* object);
	void FillInstance(const PERF_INSTANCE_DEFINITION* instance);
	void FillCounter(const PERF_COUNTER_DEFINITION* counter, const PERF_INSTANCE_DEFINITION* instance);
	void FillCounter(const PERF_COUNTER_DEFINITION* counter, const PERF_OBJECT_TYPE* object);

private:

	void FillCounterFields(const PERF_COUNTER_DEFINITION* counter);
	void FillCounterValue(const PERF_COUNTER_DEFINITION* counter, const void* value);

	void AddHex(const TCHAR* field, int val);
	void AddTime(const TCHAR* field, const SYSTEMTIME* st);
	void AddLarge(const TCHAR* field, LARGE_INTEGER li);
	void AddTextW(const TCHAR* field, const WCHAR* val);
	void AddTextW(const TCHAR* field, const WCHAR* val, int len);
	
	void AddText(const TCHAR* field, const TCHAR* val, int len);
	void AddText(const TCHAR* field, const TCHAR* val);
	void AddLongText(const TCHAR* field, const TCHAR* val);

	void AddDetailLevel(const TCHAR* field, int val);
	void AddCounterType(const TCHAR* field, int val);
};

#endif //FIELDSLIST_H