#ifndef INFODLG_H
#define INFODLG_H

#include "resource.h"

class CInfoDialog : public CDialogImpl<CInfoDialog>
{
public:

	enum {IDD = IDD_INFO};

	CInfoDialog() {}

	BEGIN_MSG_MAP(CInfoDialog)

		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)

		COMMAND_ID_HANDLER(IDCANCEL,   OnCancel)
		COMMAND_ID_HANDLER(IDOK,       OnOk)

	END_MSG_MAP()

	BOOL OnInitDialog(UINT, WPARAM, LPARAM, BOOL&)
	{
		SetDlgItemInt(IDC_INFO_LAST_COUNTER, CounterHelpDB::GetLastName(), TRUE);
		SetDlgItemInt(IDC_INFO_LAST_HELP,    CounterHelpDB::GetLastHelp(), TRUE);

		SetDlgItemInt(IDC_INFO_COUNTERS_COUNT, CounterHelpDB::GetNamesCount());
		SetDlgItemInt(IDC_INFO_HELP_COUNT,     CounterHelpDB::GetHelpCount());

		TCHAR str[10];

		int id = GetSystemDefaultUILanguage();
		wsprintf(str, TEXT("%03x"), id & 0x00FF);

		SetDlgItemText(IDC_INFO_GSDUIL, str);

		return FALSE;
	}

	//  
	LRESULT OnOk(WORD, WORD, HWND, BOOL& b)
	{
		EndDialog(1);
		return 1;
	}

	LRESULT OnCancel(WORD, WORD, HWND, BOOL& b)
	{
		EndDialog(0);
		return 1;
	}
};

#endif //OTHERDLG_H