#ifndef OBJECTSTREE_H
#define OBJECTSTREE_H

class CObjectsTree : public CTreeViewCtrl
{
public:
	CObjectsTree();
	~CObjectsTree();

	bool Create(HWND parent);
	void Clear();
	
	void Fill(int size, const void* data);

	//   
	enum
	{
		none = -1,
		system_id = 0,
		object_id = 1,
		multi_object_id = 2,
		instance_id = 3,
		fake_instance_id = 4,
		counter_id = 5
	};

	void GetCurrentItem(
			int* type, DWORD* data, 
			DWORD* parent_type, DWORD* parent_data);

private:

	bool CreateImageList();

	void FillObject(HTREEITEM parent, const PERF_OBJECT_TYPE* object);
	void FillCounters(HTREEITEM parent, const PERF_OBJECT_TYPE* object);

	
	HTREEITEM InsertW(HTREEITEM parent, const WCHAR* name, int len, int img, const void* data);
	HTREEITEM InsertTitle(HTREEITEM parent, int name, int img, const void* data);
	HTREEITEM InsertID(HTREEITEM parent, int id, int img, const void* data);

	HTREEITEM Insert(HTREEITEM parent, const TCHAR* name, int img, const void* data);
	
private:

	WTL::CImageList _image;
	bool            _sort_insertion;
};

#endif //OBJECTSTREE_H