//
//  Copyright (C) 2003,  . All Rights Reserved.
//
//  PROJECT:    Performance Counter Viewer
//
//  MODULE:     titledb.h
//
//  PURPOSE:          /
//                Matt Pietrek     MSJ March 1996
//
//  AUTHOR(S):   
//
//  PLATFORMS:  Windows NT/2000/XP
//
//  CLASSES:
//      raw_DB
//      title_DB
//

#ifndef TITLEDB_H
#define TITLEDB_H

//
//      LangId   .
class raw_DB
{
public:
	raw_DB();
	~raw_DB(); 

	void Free();

	int  LoadCounters(const TCHAR* computer = NULL, int prim_lang_id = 9);
	int  LoadExplains(const TCHAR* computer = NULL, int prim_lang_id = 9);
	
	const TCHAR* Get()     const {return _raw_titles;}
	int          GetLast() const {return _max_title;}

private:

	int Load(const TCHAR* computer, const TCHAR* title_str, const TCHAR* max_str);

	int GetMax(HKEY hklm, const TCHAR* value, int* max);
	int GetMax(const TCHAR* titles, int* max);

	int GetTitles(HKEY hkey, const TCHAR* value, TCHAR** buffer);

private:

	TCHAR*  _raw_titles;
	int     _max_title;
};

//
//     raw_DB,  
//    .
class title_DB
{
public:
	title_DB();
	~title_DB(); 

	void Free();

	int  LoadCounters(const TCHAR* computer = NULL, int prim_lang_id = 9);
	int  LoadExplains(const TCHAR* computer = NULL, int prim_lang_id = 9);

	const TCHAR* Get(int n) const;
	int Find(const TCHAR* s) const;

	int GetLast() const;
	int GetCount() const;

private:

	int ParseTitles(const raw_DB& r, TCHAR*** data);

private:

	raw_DB  _raw;
	TCHAR** _titles;
	int     _count_title;
};

#endif //TITLEDB_H