//
//  Copyright (C) 2003,  . All Rights Reserved.
//
//  PROJECT:    Performance Counter Viewer
//
//  MODULE:     titledb_for_sample.h
//
//  PURPOSE:          /
//                  -   
//              -       
//                .    
//                    titledb.h  titledb.cpp
//
//                 Matt Pietrek     MSJ March 1996
//
//  AUTHOR(S):   
//
//  PLATFORMS:  Windows NT/2000/XP
//
//  CLASSES:
//      raw_DB
//      title_DB
//

#ifndef TITLEDB_H
#define TITLEDB_H

//
//      .
// LangId     .
class raw_DB
{
public:
	raw_DB();
	~raw_DB(); 

	int  LoadHKLM(const TCHAR* title_str, const TCHAR* max_str);
	int  LoadHKPD(const TCHAR* title_str, const TCHAR* max_str);

	int  LoadHKPT(const TCHAR* title_str, const TCHAR* max_str);
	int  LoadHKPNT(const TCHAR* title_str, const TCHAR* max_str);

	void Free();

	const TCHAR* Get() const {return _raw_titles;}
	int GetLast()      const {return _max_title;}

	void SetRemote(const TCHAR* s);
	void SetLangId(const TCHAR* s);

private:

	int GetMax(HKEY hklm, const TCHAR* value, int* max);
	int GetTitles(HKEY hkey, const TCHAR* value, TCHAR** buffer);

private:

	TCHAR*  _raw_titles;
	int     _max_title;
	CString _computer;
	CString _lang_id;
};

//
//     raw_DB,  
//    .
class title_DB
{
public:
	title_DB();
	~title_DB(); 

	int  LoadHKLM(const TCHAR* title_str, const TCHAR* max_str);
	int  LoadHKPD(const TCHAR* title_str, const TCHAR* max_str);

	int  LoadHKPT(const TCHAR* title_str, const TCHAR* max_str);
	int  LoadHKPNT(const TCHAR* title_str, const TCHAR* max_str);

	void Free();

	const TCHAR* Get(int n) const;
	int Find(const TCHAR* s) const;

	int GetLast() const;
	int GetCount() const;

	void SetRemote(const TCHAR* s);
	void SetLangId(const TCHAR* s);

private:

	int ParseTitles(const raw_DB& r, TCHAR*** data);

private:

	raw_DB  _raw;
	TCHAR** _titles;
	int     _count_title;
};

#endif //TITLEDB_H