//
//  Copyright (C) 2003,  . All Rights Reserved.
//
//  PROJECT:    Performance Counter Viewer
//
//  MODULE:     counterhelpdb.cpp
//
//  PURPOSE:    ,        .
//               -     titledb_for_sample.h
//
//  AUTHOR(S):   
//
//  PLATFORMS:  Windows NT/2000/XP
//
//  FUNCTIONS:
//      

#include "stdwtl.h"
#include "titledb_for_sample.h"
#include "counterhelpdb.h"

namespace CounterHelpDB
{
	title_DB counter;
	title_DB help;

	int use_hklm = 0;
}

//////////////////////////////////////////////////////////////
//
//  
//
//////////////////////////////////////////////////////////////

int CounterHelpDB::Load()
{
	counter.Free();
	help.Free();

	int res = 0;

	if (use_hklm == 0)
	{
		res = counter.LoadHKLM(TEXT("Counter"), TEXT("Last Counter"));

		if (res != NO_ERROR)
		{
			return res;
		}

		res = help.LoadHKLM(TEXT("Help"), TEXT("Last Help"));

		if (res != NO_ERROR)
		{
			return res;
		}
	}
	else if (use_hklm == 1)
	{
		res = counter.LoadHKPD(TEXT("Counter "), TEXT("Last Counter"));

		if (res != NO_ERROR)
		{
			return res;
		}

		res = help.LoadHKPD(TEXT("Explain "), TEXT("Last Help"));

		if (res != NO_ERROR)
		{
			return res;
		}
	}
	else if (use_hklm == 2)
	{
		res = counter.LoadHKPT(TEXT("Counter"), TEXT("Last Counter"));

		if (res != NO_ERROR)
		{
			return res;
		}

		res = help.LoadHKPT(TEXT("Help"), TEXT("Last Help"));

		if (res != NO_ERROR)
		{
			return res;
		}
	}
	else if (use_hklm == 3)
	{
		res = counter.LoadHKPNT(TEXT("Counter"), TEXT("Last Counter"));

		if (res != NO_ERROR)
		{
			return res;
		}

		res = help.LoadHKPNT(TEXT("Help"), TEXT("Last Help"));

		if (res != NO_ERROR)
		{
			return res;
		}
	}

	return 0;
}

//
//
//   . NULL    - .
//
//

void CounterHelpDB::Connect(const TCHAR* c)
{
	counter.SetRemote(c);
	help.SetRemote(c);
}
	
//
//
//       
//
//

const TCHAR* CounterHelpDB::GetName(int index)
{
	return counter.Get(index);
}

const TCHAR* CounterHelpDB::GetHelp(int index)
{
	return help.Get(index);
}

int CounterHelpDB::GetLastName()
{
	return counter.GetLast();
}

int CounterHelpDB::GetLastHelp()
{
	return help.GetLast();
}

int CounterHelpDB::GetNamesCount()
{
	return counter.GetCount();
}

int CounterHelpDB::GetHelpCount()
{
	return help.GetCount();
}

//
//
// ,  LangId    
//
//

void CounterHelpDB::Use009()
{
	counter.SetLangId(TEXT("009"));
	help.SetLangId(TEXT("009"));
}

void CounterHelpDB::UseGetSystemDefaultUILanguage()
{
	int id = GetSystemDefaultUILanguage();

	TCHAR str[10];
	wsprintf(str, TEXT("%03x"), id & 0x00FF);

	counter.SetLangId(str);
	help.SetLangId(str);
}

void CounterHelpDB::UseOther(const TCHAR* other)
{
	counter.SetLangId(other);
	help.SetLangId(other);
}

//
//
// ,       
//
//

void CounterHelpDB::UseHKLM()
{
	use_hklm = 0;
}

void CounterHelpDB::UseHKPD()
{
	use_hklm = 1;
}

void CounterHelpDB::UseHKPT()
{
	use_hklm = 2;
}

void CounterHelpDB::UseHKPNT()
{
	use_hklm = 3;
}

//////////////////////////////////////////////////////////////